/*
Copyright 2011, m0skVi4a ;]
Plugin created in Rousse, Bulgaria


Plugin thread 1:
https://forums.alliedmods.net/showthread.php?t=171460

Plugin thread 2:
http://amxmodxbg.org/forum/viewtopic.php?t=37116

Original posted by m0skVi4a ;]



Description:

This is Register System. You can put a password to your name and if someone connect to the server with the same name he will be kicked if he does not login.


Commands:

say /reg
say_team /reg
Open the register system menu


CVARS:

"rs_on"			 - 	Is the plugin on(1) or off(0).   Default: 1
"rs_messages"		 - 	What messages will be displayed when player connect - only hud messages(1), only chat messages(2) or hud and chat messages(3)   Default: 3
"rs_register_time"  	 - 	How much time has the player to register. If is set to 0 registration is not mandatory.   Default: 0
"rs_login_time" 	 - 	How much time has the player to login if is registered.   Default: 60.0
"rs_password_len"	 -	What is minimum length of the password.   Default: 6
"rs_attempts"  		 - 	How much attempts has the player to login if he type wrong password.   Default: 3
"rs_chngpass_times"	 -	How much times can player change his password per map.   Default: 3
"rs_register_datetime"	 -	Is it allowed the plugin to store the register date of the user.   Default: 1
"rs_chngpass_datetime"	 -	Is it allowed the plugin to store the last change password date of the user.   Default: 1

All CVARS are without quotes


Credits:

m0skVi4a ;]    	-	for the idea and make the plugin
blndr-,-	-	for the idea for the second menu when player is registering and for the idea for the status in the title in the menu
ConnorMcLeod 	- 	for his help to block the name change for logged players
Sylwester	-	for the idea for the encrypt
dark_style	-	for ideas in the plugin


Changelog:

November 6, 2011   -  v1.0 BETA:
	-  First Release

November 20, 2011   -  v1.1 FINAL
	-  Fixed some bugs
	-  Added Change Password function
	-  Added Info/Help
	-  Added cvars to show when the player is registered and change his password
	-  Password are now encrypted for more safety

November 23, 2011   -  v1.1 FINAL FIX 1
	-  Fixed bug if user type more than CVAR setted attempts passwords

November 28, 2011   -  v1.1 FINAL FIX 2
	-  Fixed bug if that the menu does not pop up when user connect


Visit www.forums.alliedmods.net
Visit www.amxmodxbg.org 
*/


#include <amxmodx>
#include <amxmisc>
#include <fakemeta>
#include <dhudmessage>


#define TASK_MESS 2133 
#define TASK_KICK 3312 
#define SALT "8c4f4370c53e0c1e1ae9acd577dddbed"

new g_on, g_mess, g_regtime, g_logtime, g_pass_length, g_attempts, g_chp_time, g_reg_dt, g_chp_dt;
new reg_file[256], name[32], namepass[256], typedpass[32], old_pass[32], new_pass[32], passsalt[64], hash[34];
new bool:is_logged[33], bool:is_registerd[33], attempts[33], times[33];
new password[34][34];
new SayTxT;
new const prefix[]="[Регистрация ника]";

public plugin_init() 
{
	register_plugin("Register System", "1.1 FINAL FIX 1", "m0skVi4a remade I Am LeGenD ;]")

	g_on = register_cvar("rs_on", "1")
	g_mess = register_cvar("rs_messages", "3")
	g_regtime = register_cvar("rs_register_time", "0")
	g_logtime = register_cvar("rs_login_time", "60.0")
	g_pass_length = register_cvar("rs_password_length", "6")
	g_attempts = register_cvar("rs_attempts", "3")
	g_chp_time = register_cvar("rs_chngpass_times", "3")
	g_reg_dt = register_cvar("rs_register_datetime", "1")
	g_chp_dt = register_cvar("rs_chngpass_datetime", "1")

	register_menucmd(register_menuid("Main Menu"), 1023, "HandleMenu")
	register_menucmd(register_menuid("Password Menu"), 1023, "HandleConfirmPassword")
	register_clcmd("say /reg", "Menu")
	register_clcmd("say_team /reg", "Menu")
	register_clcmd("LOGIN_PASS", "Login");
	register_clcmd("REGISTER_PASS", "Register")
	register_clcmd("CHANGE_PASS", "ChangePassword")

	register_forward(FM_ClientUserInfoChanged, "NameChange")

	register_dictionary("register_system.txt")
	SayTxT = get_user_msgid("SayText")

	new configsdir[64]
	get_configsdir(configsdir, charsmax(configsdir))
	formatex(reg_file, charsmax(reg_file), "%s/regusers.ini", configsdir)

	if(!file_exists(reg_file))
	{
		write_file(reg_file,";Register System file^n;Modifying may cause users to can not Login!^n^n")
		server_print("%L", LANG_SERVER, "FILE_ERROR", reg_file)
	}
}

public client_connect(id)
{
	is_logged[id] = false
	is_registerd[id] = false
	attempts[id] = 0
	remove_task(id+TASK_MESS)
	remove_task(id+TASK_KICK)
}

public client_disconnect(id)
{
	is_logged[id] = false
	is_registerd[id] = false
	attempts[id] = 0
	remove_task(id+TASK_MESS)
	remove_task(id+TASK_KICK)
}

public client_putinserver(id)
{
	if(get_pcvar_num(g_on))
	{
		new file_name[32], file_pass[34];
		new file = fopen(reg_file, "r")
	
		while(!feof(file))
		{
			get_user_name(id, name, 31)
			fgets(file, namepass, 255)
			parse(namepass, file_name, 31, file_pass, 33)
			
			if(namepass[0] == ';')
				continue
			
			if(equal(file_name, name))
			{
				is_registerd[id] = true
				password[id] = file_pass
				
				break
			}
		}
		fclose(file)
		
		set_task(5.0, "Messages", id+TASK_MESS)
		
		if(!is_registerd[id])
		{
			if(get_pcvar_float(g_regtime) != 0)
			{
				set_task(get_pcvar_float(g_regtime) + 5, "KickPlayer", id+TASK_KICK)
			}
		}
		else
		{
			set_task(get_pcvar_float(g_logtime) + 5, "KickPlayer", id+TASK_KICK)
		}
	}
}

public Messages(id)
{
	id -= TASK_MESS
	
	if(get_pcvar_num(g_mess) == 1 || get_pcvar_num(g_mess) == 3)
	{
		if(!is_registerd[id])
		{
			if(get_pcvar_num(g_regtime) != 0)
			{
				set_dhudmessage(255, 0, 0, -1.0, -1.0, 0, 0.5, 5.0, 2.0, 2.0, -1)
				show_dhudmessage(id, "%L", LANG_SERVER, "REGISTER_HUD", get_pcvar_num(g_regtime))
			}
			else
			{
				set_dhudmessage(0, 255, 0, -1.0, -1.0, 0, 0.5, 5.0, 2.0, 2.0, -1)
				show_dhudmessage(id, "%L", LANG_SERVER, "YOUCANREG_HUD", get_pcvar_num(g_regtime))
			}
		}
		else
		{
			set_hudmessage(255, 0, 0, -1.0, -1.0, 0, 0.5, 5.0, 2.0, 2.0, -1)
			show_hudmessage(id, "%L", LANG_SERVER, "LOGIN_HUD", get_pcvar_num(g_logtime))
		}	
	}

	if(get_pcvar_num(g_mess) == 2 || get_pcvar_num(g_mess) == 3)
	{
		if(!is_registerd[id])
		{
			if(get_pcvar_num(g_regtime) != 0)
			{
				client_printcolor(id, "%L", LANG_SERVER, "REGISTER_CHAT", prefix, get_pcvar_num(g_regtime))
			}
			else
			{
				client_printcolor(id, "%L", LANG_SERVER, "YOUCANREG_CHAT", prefix, get_pcvar_num(g_regtime))
			}
		}
		else
		{
			client_printcolor(id, "%L", LANG_SERVER, "LOGIN_CHAT", prefix, get_pcvar_num(g_logtime))
		}
	}
	Menu(id)
}

public Menu(id)
{
	if(get_pcvar_num(g_on) && is_user_connected(id))
	{
		static menu[512];
		new keys, lenght;
		lenght = 0

		if(is_registerd[id])
		{
			if(is_logged[id])
			{
				lenght += formatex(menu[lenght], charsmax(menu), "%L%L", LANG_SERVER, "MENU_LOG", LANG_SERVER, "MENU_EXIT")
				keys = MENU_KEY_3|MENU_KEY_4|MENU_KEY_0
			}
			else
			{
				lenght += formatex(menu[lenght], charsmax(menu), "%L", LANG_SERVER, "MENU_REG")
				keys = MENU_KEY_1|MENU_KEY_4
			}
		}
		else
		{		
			lenght += formatex(menu[lenght], charsmax(menu), "%L", LANG_SERVER, "MENU_NOT_REG", get_pcvar_num(g_regtime) != 0 ? "" : "\w")
			keys = MENU_KEY_2|MENU_KEY_4
			
			if(get_pcvar_num(g_regtime) == 0)
			{
				lenght += formatex(menu[lenght], charsmax(menu), "%L", LANG_SERVER, "MENU_EXIT")
				keys |= (MENU_KEY_0)
			}
		}
		show_menu(id, keys, menu, -1, "Main Menu")
	}
}

public HandleMenu(id, key)
{
	switch(key)
	{
		case 0:
		{
			client_cmd(id, "messagemode LOGIN_PASS")
			Menu(id)
		}
		case 1:
		{
			client_cmd(id, "messagemode REGISTER_PASS")
			Menu(id)
		}
		case 2:
		{
			client_cmd(id, "messagemode CHANGE_PASS")
			Menu(id)
		}
		case 3:
		{
			Info(id)
			Menu(id)
		}
		case 9:
		{
			return PLUGIN_HANDLED
		}
	}
	return PLUGIN_HANDLED
}

public Info(id)
{
	show_motd(id, "rshelpmotd.txt", "Register System Help")
}

public Login(id)
{
	if(get_pcvar_num(g_on))
	{
		read_argv(1, typedpass, 31)

		if(!is_registerd[id])
		{	
			client_printcolor(id, "%L", LANG_SERVER, "LOG_NOTREG", prefix)
			return
		}

		if(is_logged[id])
		{
			client_printcolor(id, "%L", LANG_SERVER, "LOG_LOGGED", prefix);
			return
		}

		formatex(passsalt, charsmax(passsalt), "%s%s", typedpass, SALT)
		md5(passsalt, hash)

		if(!equal(hash, password[id]))
		{	
			attempts[id]++
			client_printcolor(id, "%L", LANG_SERVER, "LOG_PASS_INVALID", prefix, attempts[id], get_pcvar_num(g_attempts))

			if(attempts[id] >= get_pcvar_num(g_attempts))
			{
				KickPlayer(id+TASK_KICK)
			}
			else
			{
				client_cmd(id, "messagemode LOGIN_PASS")
			}
		}
		else
		{
			is_logged[id] = true
			attempts[id] = 0
			remove_task(id)
			client_printcolor(id, "%L", LANG_SERVER, "LOG_LOGING", prefix)
			Menu(id)
		}
	}
}

public Register(id)
{
	if(get_pcvar_num(g_on))
	{
		read_argv(1, typedpass, 31)
		new passlength = strlen(typedpass)

		if(equal(typedpass, ""))
			return
			
		if(is_registerd[id])
		{
			client_printcolor(id, "%L", LANG_SERVER, "REG_EXISTS", prefix)
			return
		}
		
		if(passlength < get_pcvar_num(g_pass_length))
		{
			client_printcolor(id, "%L", LANG_SERVER, "REG_LEN", prefix, get_pcvar_num(g_pass_length))
			client_cmd(id, "messagemode REGISTER_PASS")
			return
		}
		password[id] = typedpass
		ConfirmPassword(id)
	}
}

public ChangePassword(id)
{
	if(get_pcvar_num(g_on))
	{
		if(!is_registerd[id] || !is_logged[id])
			return
			
		read_argv(1, typedpass, 31)
		parse(typedpass, old_pass, 31, new_pass, 31)
		formatex(passsalt, charsmax(passsalt), "%s%s", old_pass, SALT)
		md5(passsalt, hash)
		
		new passlenght = strlen(new_pass)
		
		if(equal(typedpass, ""))
			return

		if(!equali(hash, password[id]))
		{
			client_printcolor(id, "%L", LANG_SERVER, "CHANGE_NO", prefix)
			return
		}
		
		if(times[id] >= get_pcvar_num(g_chp_time))
		{
			client_printcolor(id, "%L", LANG_SERVER, "CHANGE_TIMES", prefix, get_pcvar_num(g_chp_time))
			return
		}

		if(passlenght < get_pcvar_num(g_pass_length))
		{
			client_printcolor(id, "%L", LANG_SERVER, "REG_LEN", prefix, get_pcvar_num(g_pass_length))
			client_cmd(id, "messagemode CHANGE_PASS")
			return
		}
		password[id] = new_pass
		ConfirmPassword(id)		
	}
}

public ConfirmPassword(id)
{
	if(get_pcvar_num(g_on) && is_user_connected(id))
	{
		static passmenu[256];
		new keys;

		formatex(passmenu, charsmax(passmenu), "%L", LANG_SERVER, "MENU_PASS", password[id])
		keys = MENU_KEY_1|MENU_KEY_2|MENU_KEY_0
		
		show_menu(id, keys, passmenu, -1, "Password Menu")
	}
}

public HandleConfirmPassword(id, key)
{
	switch(key)
	{
		case 0:
		{
			new datetime[26];
			get_user_name(id, name, 31)
			get_time("on %d/%m/%Y at %H:%M:%S", datetime, 25)
			formatex(passsalt, charsmax(passsalt), "%s%s", password[id],  SALT)
			md5(passsalt, hash)

			if(is_registerd[id])
			{
				new file = fopen(reg_file, "r");
				new line;

				while(!feof(file))
				{
					fgets(file, namepass, 255)
					line++
					parse(namepass, namepass, charsmax(namepass))

					if(equal(namepass, name))
					{						
						if(get_pcvar_num(g_chp_dt))
						{	
							format(namepass, charsmax(namepass), "^"%s^" ^"%s^" //Password changed %s", name, hash, datetime)
						}
						else
						{
							format(namepass, charsmax(namepass), "^"%s^" ^"%s^"", name, hash)
						}
						write_file(reg_file, namepass, line - 1)
						password[id] = new_pass
						client_printcolor(id, "%L", LANG_SERVER, "CHANGE_NEW", prefix, new_pass)
						times[id]++

						break
					}
				}
				fclose(file)				
			}
			else
			{
				new file = fopen(reg_file, "a")
				if(get_pcvar_num(g_reg_dt))
				{
					format(namepass, charsmax(namepass), "^n^"%s^" ^"%s^"^n;Account Created %s^n", name, hash, datetime)
				}
				else
				{
					format(namepass, charsmax(namepass), "^n^"%s^" ^"%s^"", name, hash)
				}
				fprintf(file, namepass)
				fclose(file)
				remove_task(id+TASK_KICK)
				set_task(get_pcvar_float(g_logtime), "KickPlayer", id)
				client_printcolor(id, "%L", LANG_SERVER, "REG_REGIS", prefix, password[id], get_pcvar_num(g_logtime))
				is_registerd[id] = true
				password[id] = hash
			}			
			Menu(id)
			
		}
		case 1:
		{
			password[id] = old_pass
			if(is_registerd[id])
			{
				client_cmd(id, "messagemode CHANGE_PASS")
			}
			else
			{
				client_cmd(id, "messagemode REGISTER_PASS")
			}
		}
		case 9:
		{
			Menu(id)
			password[id] = old_pass
			return PLUGIN_HANDLED
		}
	}
	return PLUGIN_HANDLED
}

public NameChange(id) 
{
	static const name[] = "name"
	new oldname[32], newname[32]
	pev(id, pev_netname, oldname, charsmax(oldname))
	if(oldname[0])
	{
		get_user_info(id, name, newname, charsmax(newname))
		if(!equal(oldname, newname))
		{
			if(is_logged[id])
			{
				set_user_info(id, name, oldname)
				client_printcolor(id, "%L", LANG_SERVER, "NAME_CHANGE", prefix)
				return FMRES_HANDLED
			}
			else if(is_registerd[id])
			{
				is_registerd[id] = false
				remove_task(id+TASK_KICK)
			}			
		}
	}
	return FMRES_IGNORED
}

public KickPlayer(id)
{
	id -= TASK_KICK

	if(is_user_connected(id))
	{
		new userid = get_user_userid(id)
		
		if(!is_registerd[id] && get_pcvar_num(g_regtime) != 0)
		{
			server_cmd("kick #%i ^"%L^"", userid, LANG_PLAYER, "KICK_REG")
		}
		else if(attempts[id] >= get_pcvar_num(g_attempts))
		{
			server_cmd("kick #%i ^"%L^"", userid, LANG_PLAYER, "KICK_ATMP", get_pcvar_num(g_attempts))
		}
		else if(is_registerd[id] && !is_logged[id])
		{
			server_cmd("kick #%i ^"%L^"", userid, LANG_PLAYER, "KICK_LOG")
		}
	}
	return PLUGIN_CONTINUE
}

stock client_printcolor(const id, const input[], any:...)
{
	new count = 1, players[32];
	static msg[191];
	vformat(msg, 190, input, 3)
	replace_all(msg,190,"!g","^4")
	replace_all(msg,190,"!n","^1")
	replace_all(msg,190,"!t","^3")
	replace_all(msg,190,"!w","^0")
	if(id) players[0] = id
	else get_players(players , count , "ch")
	{
		for(new i = 0; i < count; i++)
		{
			if(is_user_connected(players[i]))
			{
				message_begin(MSG_ONE_UNRELIABLE, SayTxT,_, players[i])
				write_byte(players[i])
				write_string(msg)
				message_end()
			}
		}
	}
}
